# This file was automatically generated by SWIG (http://www.swig.org).
# Version 2.0.10
#
# Do not make changes to this file unless you know what you are doing--modify
# the SWIG interface file instead.



from sys import version_info
if version_info >= (2,6,0):
    def swig_import_helper():
        from os.path import dirname
        import imp
        fp = None
        try:
            fp, pathname, description = imp.find_module('_lightflagger', [dirname(__file__)])
        except ImportError:
            import _lightflagger
            return _lightflagger
        if fp is not None:
            try:
                _mod = imp.load_module('_lightflagger', fp, pathname, description)
            finally:
                fp.close()
            return _mod
    _lightflagger = swig_import_helper()
    del swig_import_helper
else:
    import _lightflagger
del version_info
try:
    _swig_property = property
except NameError:
    pass # Python < 2.2 doesn't have 'property'.
def _swig_setattr_nondynamic(self,class_type,name,value,static=1):
    if (name == "thisown"): return self.this.own(value)
    if (name == "this"):
        if type(value).__name__ == 'SwigPyObject':
            self.__dict__[name] = value
            return
    method = class_type.__swig_setmethods__.get(name,None)
    if method: return method(self,value)
    if (not static):
        self.__dict__[name] = value
    else:
        raise AttributeError("You cannot add attributes to %s" % self)

def _swig_setattr(self,class_type,name,value):
    return _swig_setattr_nondynamic(self,class_type,name,value,0)

def _swig_getattr(self,class_type,name):
    if (name == "thisown"): return self.this.own()
    method = class_type.__swig_getmethods__.get(name,None)
    if method: return method(self)
    raise AttributeError(name)

def _swig_repr(self):
    try: strthis = "proxy of " + self.this.__repr__()
    except: strthis = ""
    return "<%s.%s; %s >" % (self.__class__.__module__, self.__class__.__name__, strthis,)

try:
    _object = object
    _newclass = 1
except AttributeError:
    class _object : pass
    _newclass = 0


class lightflagger(_object):
    """Proxy of C++ casac::lightflagger class"""
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, lightflagger, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, lightflagger, name)
    __repr__ = _swig_repr
    def __init__(self): 
        """__init__(self) -> lightflagger"""
        this = _lightflagger.new_lightflagger()
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _lightflagger.delete_lightflagger
    __del__ = lambda self : None;
    def open(self, *args, **kwargs):
        """
        open(self, msname=string("")) -> bool

        Summary
        	Attaches tool to a measurement set.

        Description
        	
        This function attaches the tool to a measurement set. If
        a measurement set is already attached, it will first detach it, 
        and then attach the tool to the new measurement set. 


        Input Parameters:
        	msname		 Measurement set to be processed 
        	
        Example:
        	

        fg.open('3C273XC1.MS')


        --------------------------------------------------------------------------------
        	      
        """
        return _lightflagger.lightflagger_open(self, *args, **kwargs)

    def setdata(self, *args, **kwargs):
        """
        setdata(self, field=string(""), spw=string(""), array=string(""), feed=string(""), scan=string(""), 
            baseline=string(""), uvrange=string(""), time=string(""), correlation=string("")) -> bool

        Summary
        	Set the data selection parameters to define a
           subset of the data on which to perform any further selections/operations.
         For unspecified parameters, the full data range is assumed.
        All data selection parameters follow the ms-selection syntax.


        Description
        	


        Input Parameters:
        	field		 Field indices or source names : example : '2,3C48' 
        	spw		 Spectral Window Indices or names : example : '1,2' 
        	array		 Array Indices or names : example : 'VLAA' 
        	feed		 Feed index or name : example : '1,2' 
        	scan		 Scan number : example : '1,2,3' 
        	baseline	 Baseline number : example : '2-3,4-5,132 ????' 
        	uvrange		 UV-distance range, with a unit : example : '2.0-3000.0 m' 
        	time		 Time range, as MJDs or date strings : example : 'xx.x.x.x.x~yy.y.y.y.y' 
        	correlation	 Correlations/polarizations : example : 'RR,LL,RL,LR,XX,YY,XY,YX' 
        	
        --------------------------------------------------------------------------------
        	      
        """
        return _lightflagger.lightflagger_setdata(self, *args, **kwargs)

    def getparameters(self, *args, **kwargs):
        """
        getparameters(self, algorithm=string("none")) -> record *

        Summary
        	 Retrieve the current set of input parameters for a specified algorithm.
           n This returns a python dictionary of parameters and their values.
           

        Description
        	
        Retrieve the current set of input parameters for a specified algorithm.


        Input Parameters:
        	algorithm	 Autoflag Algorithm name timemed freqmed none 
        	
        --------------------------------------------------------------------------------
        	      
        """
        return _lightflagger.lightflagger_getparameters(self, *args, **kwargs)

    def setparameters(self, *args, **kwargs):
        """
        setparameters(self, algorithm=string("none"), parameters=initialize_record("")) -> bool

        Summary
        	Setup an autoflag algorithm.
           

        Description
        	
        Setup an autoflag algorithm.


        Input Parameters:
        	algorithm	 Autoflag Algorithm name timemedian freqmedian spectralreject uvbin none 
        	parameters	 Parameters for each autoflag algorithm. 
        	
        --------------------------------------------------------------------------------
        	      
        """
        return _lightflagger.lightflagger_setparameters(self, *args, **kwargs)

    def run(self, *args, **kwargs):
        """
        run(self, parameters=initialize_record("")) -> record *

        Summary
        	Executes a flagging run

        Description
        	
        Executes a flagging run.


        Input Parameters:
        	parameters	 Generic parameters 
        	
        Example:
        	

        --------------------------------------------------------------------------------
        	      
        """
        return _lightflagger.lightflagger_run(self, *args, **kwargs)

    def done(self):
        """
        done(self) -> bool

        Summary
        	Destroys the flag tool

        Description
        	

        This function destroys the flag tool.


        Example:
        	
        - fg.done()
        T
        -

        --------------------------------------------------------------------------------
        	      
        """
        return _lightflagger.lightflagger_done(self)

    def saveflagversion(self, *args, **kwargs):
        """
        saveflagversion(self, versionname=string(""), comment=string(""), merge=string("")) -> bool

        Summary
        	*** n Save current flags with a version name.*** 
           			

        Description
        	 


        Input Parameters:
        	versionname	 Version name 
        	comment		 Comment for this flag table 
        	merge		 merge type 
        	
        --------------------------------------------------------------------------------
        	      
        """
        return _lightflagger.lightflagger_saveflagversion(self, *args, **kwargs)

    def restoreflagversion(self, *args, **kwargs):
        """
        restoreflagversion(self, versionname=std::vector< string >(1, ""), merge=string("")) -> bool

        Summary
        	*** n Restore flags from a saved flag_version. 
        			n versionname : name of flag version to restore to main table
        			n merge : Type of operation to perform during restoration.
        			n        merge = replace  : replaces the main table flags.
        			n        merge = and   : logical AND with main table flags
        			n        merge = or    : logical OR with main table flags
        			n        Default : replace.
         			  n ***

        Description
        	 


        Input Parameters:
        	versionname	 Version name 
        	merge		 merge type 
        	
        --------------------------------------------------------------------------------
        	      
        """
        return _lightflagger.lightflagger_restoreflagversion(self, *args, **kwargs)

    def deleteflagversion(self, *args, **kwargs):
        """
        deleteflagversion(self, versionname=std::vector< string >(1, "")) -> bool

        Summary
        	*** n Delete a saved flag_version. 
         			   ***

        Description
        	 


        Input Parameters:
        	versionname	 Version name 
        	
        --------------------------------------------------------------------------------
        	      
        """
        return _lightflagger.lightflagger_deleteflagversion(self, *args, **kwargs)

    def getflagversionlist(self, printflags=True):
        """
        getflagversionlist(self, printflags=True) -> std::vector< std::string >

        Summary
        	*** n Print out a list of saved flag_versions. 
         			  ***

        Description
        	 
        Print out the list of flag versions in the MS, unless the parameter printflags=False. The list of names is returned.


        Input Parameters:
        	printflags	 Print flagversions in logger? true 
        	
        --------------------------------------------------------------------------------
        	      
        """
        return _lightflagger.lightflagger_getflagversionlist(self, printflags)

lightflagger_swigregister = _lightflagger.lightflagger_swigregister
lightflagger_swigregister(lightflagger)

# This file is compatible with both classic and new-style classes.


