#
# This file was generated using xslt from its XML file
#
# Copyright 2013, Associated Universities Inc., Washington DC
#
import sys
import os
#from casac import *
import casac
import string
import time
import inspect
import gc
import numpy
from odict import odict
from taskmanager import tm
from task_plotxy import plotxy
class plotxy_cli_:
    __name__ = "plotxy"
    __async__ = {}
    rkey = None
    i_am_a_casapy_task = None
    # The existence of the i_am_a_casapy_task attribute allows help()
    # (and other) to treat casapy tasks as a special case.

    def __init__(self) :
       self.__bases__ = (plotxy_cli_,)
       self.__doc__ = self.__call__.__doc__

       self.parameters={'vis':None, 'xaxis':None, 'yaxis':None, 'datacolumn':None, 'iteration':None, 'selectdata':None, 'antenna':None, 'spw':None, 'field':None, 'uvrange':None, 'timerange':None, 'correlation':None, 'scan':None, 'feed':None, 'array':None, 'averagemode':None, 'width':None, 'timebin':None, 'crossscans':None, 'crossbls':None, 'crossarrays':None, 'stackspw':None, 'restfreq':None, 'frame':None, 'doppler':None, 'extendflag':None, 'extendcorr':None, 'extendchan':None, 'extendspw':None, 'extendant':None, 'extendtime':None, 'subplot':None, 'plotsymbol':None, 'plotcolor':None, 'markersize':None, 'linewidth':None, 'plotrange':None, 'multicolor':None, 'selectplot':None, 'overplot':None, 'newplot':None, 'clearpanel':None, 'skipnrows':None, 'title':None, 'xlabels':None, 'ylabels':None, 'fontsize':None, 'windowsize':None, 'showflags':None, 'interactive':None, 'figfile':None, 'end':None,  'async':None}


    def result(self, key=None):
	    #### here we will scan the task-ids in __async__
	    #### and add any that have completed...
	    if key is not None and self.__async__.has_key(key) and self.__async__[key] is not None:
	       ret = tm.retrieve(self.__async__[key])
	       if ret['state'] == "done" :
	          self.__async__[key] = None
	       elif ret['state'] == 'crashed' :
		  self.__async__[key] = None
	       return ret
	    return None


    def __call__(self, vis=None, xaxis=None, yaxis=None, datacolumn=None, iteration=None, selectdata=None, antenna=None, spw=None, field=None, uvrange=None, timerange=None, correlation=None, scan=None, feed=None, array=None, averagemode=None, width=None, timebin=None, crossscans=None, crossbls=None, crossarrays=None, stackspw=None, restfreq=None, frame=None, doppler=None, extendflag=None, extendcorr=None, extendchan=None, extendspw=None, extendant=None, extendtime=None, subplot=None, plotsymbol=None, plotcolor=None, markersize=None, linewidth=None, plotrange=None, multicolor=None, selectplot=None, overplot=None, newplot=None, clearpanel=None, skipnrows=None, title=None, xlabels=None, ylabels=None, fontsize=None, windowsize=None, showflags=None, interactive=None, figfile=None, end=None,  async=None):

        """An X-Y plotter/interactive flagger for visibility data.

	Detailed Description: 

             Selected data can be flexibly plotted with a wide variety
	     of axes and averaging options, including iteration over
	     antennas and fields.  Data may be listed, flagged or
	     unflagged interactively.  The plots can be zoomed and
	     also saved to a file.  

             It is advisable to run flagmanager before using plotxy to
	     flag data in order to save the current flag state before
	     altering:
	     flagmanager(vis='vis_name',mode='save',versionname='before_plotxy',
	     comment=versionname)
	
	
	Arguments :
		vis:	Name of input visibility dataset
		   Default Value: 

		xaxis:	X-axis: def = \'time\': see help for options
		   Default Value: time
		   Allowed Values:
				azimuth
				elevation
				hourangle
				parallacticangle
				baseline
				chan
				channel
				corr
				correlation
				freq
				frequency
				time
				velocity
				vel
				velo
				u
				v
				w
				uvdist
				x
				amp
				phase
				real
				imag
				weight

		yaxis:	Y-axis: def = \'amp\': see help for options
		   Default Value: amp
		   Allowed Values:
				azimuth
				elevation
				hourangle
				parallacticangle
				baseline
				corr
				correlation
				u
				v
				w
				uvdist
				amp
				phase
				real
				imag
				weight
				time

		datacolumn:	data (raw), corrected, model, residual (corrected - model)
		   Default Value: data
		   Allowed Values:
				data
				corrected
				model
				residual

		iteration:	Plot separate panels by field, antenna, baseline, scan, feed
		   Default Value: 

		selectdata:	More data selection parameters (antenna, timerange etc)
		   Default Value: True

		antenna:	antenna/baselines: \'\'==&gt;all, antenna = \'3,VA04\'
		   Default Value: 

		spw:	Spectral windows:channels: \'\'==&gt;all, spw=\'2:5~57\'
		   Default Value: 

		field:	Field names or field index numbers: \'\'==&gt;all, field=\'0~2,3C286\'
		   Default Value: 

		uvrange:	uv range: \'\'==&gt;all; uvrange = \'0~100klambda\'
		   Default Value: 

		timerange:	time range: \'\'==&gt;all, timerange=\'09:14:0~09:54:0\'
		   Default Value: 

		correlation:	correlations: \'\'==&gt;all, correlations=\'RR LL\'
		   Default Value: 

		scan:	scan numbers: \'\'==&gt;all
		   Default Value: 

		feed:	multi-feed numbers: Not yet implemented
		   Default Value: 

		array:	(sub)array numbers: \'\'==&gt;all
		   Default Value: 

		averagemode:	Select averaging type: \'vector\', \'scalar\'
		   Default Value: 
		   Allowed Values:
				
				vector
				scalar

		width:	number of channels to average, default: \'1\', Also: \'all\', \'allspw\'
		   Default Value: 1

		timebin:	Averaging time in seconds, default=\'0\', also: \'all\'
		   Default Value: 0

		crossscans:	have time averaging cross over scans?
		   Default Value: False

		crossbls:	have averaging cross over baselines?
		   Default Value: False

		crossarrays:	have averaging cross over arrays?
		   Default Value: False

		stackspw:	stack multiple spw on top of each other?
		   Default Value: False

		restfreq:	a frequency quanta or transition name. see help for options
		   Default Value: 

		frame:	frequency frame for spectral axis. see help for options
		   Default Value: 
		   Allowed Values:
				
				LSRK
				REST
				TOPO
				LSRD
				BARY
				GEO
				GALACTO
				LGROUP
				CMB

		doppler:	doppler mode. see help for options
		   Default Value: 
		   Allowed Values:
				
				RADIO
				Z
				RATIO
				BETA
				GAMMA
				OPTICAL
				TRUE
				RELATIVISTIC

		extendflag:	have flagging extend to other data points?
		   Default Value: False

		extendcorr:	extend flags based on correlation: \'\'==&gt; selectdata,\'half\', or \'all\' 
		   Default Value: 
		   Allowed Values:
				
				all
				half

		extendchan:	extend flags based on channel: \'\'==&gt; selectdata or \'all\'
		   Default Value: 
		   Allowed Values:
				
				all

		extendspw:	extend flags based on spw: \'\'==&gt; selectdata or \'all\'
		   Default Value: 
		   Allowed Values:
				
				all

		extendant:	extend flags based on antenna: \'\'==&gt; selectdata or \'all\'
		   Default Value: 
		   Allowed Values:
				
				all

		extendtime:	extend flags based on time: \'\'==&gt; selectdata or \'all\'
		   Default Value: 
		   Allowed Values:
				
				all
				scan
				field

		subplot:	Multipanel display scheme (yxn)
		   Default Value: 111

		plotsymbol:	Options include . : , o ^ v &gt; &lt; s + x D d 2 3 4 h H | _
		   Default Value: .

		plotcolor:	Plot color
		   Default Value: darkcyn

		markersize:	Size of plotted marks
		   Default Value: 5.0

		linewidth:	Width of plotted lines
		   Default Value: 1.0

		plotrange:	The range of data to be plotted (see help)
		   Default Value: -1-1-1-1

		multicolor:	Plot in different colors: Options: none, both, chan, corr
		   Default Value: corr
		   Allowed Values:
				corr
				correlation
				none
				both
				chan
				channel

		selectplot:	Select additional plotting options (e.g, fontsize, title,etc)
		   Default Value: False

		overplot:	Overplot on current plot (if possible)
		   Default Value: False

		newplot:	Replace the last plot or not when overplotting
		   Default Value: False

		clearpanel:	Specify if old plots are cleared or not
		   Default Value: Auto
		   Allowed Values:
				Current
				None
				Auto
				All

		skipnrows:	Plot every nth point
		   Default Value: 0

		title:	Plot title (above plot)
		   Default Value: 

		xlabels:	Label for x-axis
		   Default Value: 

		ylabels:	Label for y-axis
		   Default Value: 

		fontsize:	Font size for labels
		   Default Value: 10.0

		windowsize:	Window size: not yet implemented
		   Default Value: 1.0

		showflags:	Show flagged data?
		   Default Value: False

		interactive:	Show plot on gui?
		   Default Value: True

		figfile:	\'\'= no plot hardcopy, otherwise supply name
		   Default Value: 

		end:	Quit plotting?
		   Default Value: False

	Returns: void

	Example :


	An X-Y plotter/interactive flagger for visibility data. 

             Selected data can be flexibly plotted with a wide variety
	     of axes and averaging options, including iteration over
	     antennas and fields.  Data may be listed, flagged or
	     unflagged interactively.  The plots can be zoomed and
	     also saved to a file.  

             It is advisable to run flagmanager before using plotxy to
	     flag data in order to save the current flag state before
	     altering:
	     flagmanager(vis='vis_name',mode='save',versionname='before_plotxy',
	     comment=versionname)

             See hints on using plotxy at the end.

	     
     Keyword arguments:
     vis -- Name of input visibility file
             default: none.  example: vis='ngc5921.ms'
     xaxis -- Visibility data to plot along the x-axis
             default: 'time'

             Options for BOTH x-axis and y-axis
	        'time','uvdist','chan', 'corr','freq','velo', 'u','v','w',
	        'azimuth','elevation','baseline','hourangle','parallacticangle'
                'amp','phase','real','imag','weight'.  'x' gives antenna array
	     
     yaxis -- Visibility data to plot along the y-axis
             default: 'amp'
             Options: same as on xaxis:

       >>> yaxis expandable parameter
         datacolumn -- Visibility file data column
             Note: this parameter is automatically shown whenever the
             chosen yaxis is a data quantity (i.e. amp)
             default: 'data'; example: datacolumn='model'
             Options: 'data' (raw),'corrected','model','residual'(corrected-model)

      --- Data Selection (see help par.selectdata for more detailed information)

     field -- Select field using field id(s) or field name(s).
              ['go listobs' to obtain the list id's or names]
            default: ''=all fields
            If field string is a non-negative integer, it is assumed to
               be a field index otherwise, it is assumed to be a field name
            field='0~2'; field ids 0,1,2
            field='0,4,5~7'; field ids 0,4,5,6,7
            field='3C286,3C295'; field named 3C286 and 3C295
            field = '3,4C*'; field id 3, all names starting with 4C
     spw -- Select spectral window/channels 
             spw='0~2,4'; spectral windows 0,1,2,4 (all channels)
             spw='<2';  spectral windows less than 2 (i.e. 0,1)
             spw='0:5~61'; spw 0, channels 5 to 61, INCLUSIVE
             spw='*:5~61'; all spw with channels 5 to 61
             spw='0,10,3:3~45'; spw 0,10 all channels, spw 3, channels 3 to 45.
             spw='0~2:2~6'; spw 0,1,2 with channels 2 through 6 in each.
             spw='0:0~10;15~60'; spectral window 0 with channels 0-10,15-60
                       NOTE ';' to separate channel selections
             spw='0:0~10^2,1:20~30^5'; spw 0, channels 0,2,4,6,8,10,
                   spw 1, channels 20,25,30
     selectdata -- Other data selection parameters
            default: True
       >>> selectdata expandable parameters
         timerange  -- Select data based on time range:
            default = '' (all); examples,
            timerange = 'YYYY/MM/DD/hh:mm:ss~YYYY/MM/DD/hh:mm:ss'
            Note: if YYYY/MM/DD is missing date defaults to first day in data set
            timerange='09:14:0~09:54:0' picks 40 min on first day
            timerange= '25:00:00~27:30:00' picks 1 hr to 3 hr 30min on next day
            timerange='09:44:00' data within one integration of time
            timerange='>10:24:00' data after this time
         antenna -- Select data based on antenna/baseline
            default: ''=all
            If antenna string is a non-negative integer, it is assumed
              to be an antenna index, otherwise it is assumed to be an
              antenna name
            antenna='5&6'; baseline between antenna index 5 and index 6.
            antenna='VA05&VA06'; baseline between VLA antenna 5 and 6.
            antenna='5&6;7&8'; baseline 5-6 and 7-8
            antenna='5'; all baselines with antenna index 5
	    antenna= '05'; all baselines with antenna named 05
            antenna='5,6,9'; all baselines with antennas indices 5,6 and 9
         correlation -- Select correlations:
            default: '' = all correlations. Other options are any combination
	                  of values from one of the valid lists:
			  'RR','LL','RL','LR','RR LL','RL LR',
			  'XX','YY','XY','YX','XX YY','XY YX'
         uvrange -- Select data within uvrange (default units meters)
            default: ''=all; example:
            uvrange='0~1000klambda'; uvrange from 0-1000 kilo-lambda
            uvrange='>4klambda';uvranges greater than 4 kilo-lambda
            uvrange='0~1000km'; uvrange in kilometers
         scan -- Scan number range
         array -- (Sub)-array number range - under development
         feed -- Multi-feed number range - under development
	 
     averagemode -- Select average mode
            default: 'vector' 
            Options: 'vector' = average over real and image part separately.
                     'scalar' = scalar average of amplitude, vector
                                    average of the phase.
                     ''       = no averaging
       >>> averagemode expandable parameters
         timebin -- length of time intervals to average
                  default: '0'= no time averaging
                  example: timebin='60' (average over 60 second interval).
                  example: timebin='all' (all times obeying other selection
                         parameters, i.e. timerange and crossscans)
         crossscans -- Have time averaging cross scan boundaries? 
              default: False=time averaging does not cross scan boundaries 
         crossbls -- Have averaging cross baseline boundaries? 
              default: False= averaging does not cross baseline boundaries 
         crossarrays -- Have averaging cross array boundaries? 
              default: False=averaging does not cross array boundaries 
         stackspw -- Stack multiple spw on top of each other?
              default: False= layout spws side-by-side for xaxis='channel'
         width -- number of channels to average
              default: '1'= no channel averaging
              example: width='32' (average 32 channels together).
              example: width='all' (all channels within each selected spw)
              example: width='allspw' (all channels and all spw averaged.)
     restfreq -- Set rest frequency or transition name
              options: (str) '' a frequency quanta or transition name
              default: currently set rest frequency and frame in MS
                     see measures for known lines, e.g.
                     me.linelist() to list lines
                     me.me.spectralline to get frequency
              example: restfreq='1420405751.786Hz' 21cm HI frequency
                     restfreq='HI'               21cm HI transition name
                     restfreq='115.2712GHz'      CO line
       >>> restfreq expandable parameters
         frame -- frequency frame for spectral axis
              options: (str) 'LSRK','REST','TOPO','LSRD','BARY',
                       'GEO','GALACTO','LGROUP','CMB'
              default: currently set frequency frame in MS
                       see measures (me.frequency) for description
         doppler -- doppler mode
              options: (str) 'RADIO','Z','RATIO','BETA','GAMMA',
                       'OPTICAL','TRUE','RELATIVISTIC'
              default: currently set doppler system in MS
                       see measures (me.doppler) for description
     extendflag -- flagging extension parameters
         default: False= no extension, only flag selected data; 
         example: extendflag=True 
       >>> extendflag expandable parameters
         extendcorr  -- Extend flagging based on correlation:
            default: ''= no correlation based extension
            examples:
            extendcorr = 'all'
            extendcorr = 'half' flags RR and LL
         extendchan -- Extend flagging based on channel:
            default: ''= no channel based extension
            example:
            extendchan = 'all'
         extendspw -- Extend flagging based on spectral window:
            default: '' = no spectral window based extension
            example:
            extendspw = 'all'
         extendant -- Extend flagging based on antenna (baseline):
            default: ''= no antenna based extension
            example:
            extendant = 'all'
         extendtime -- Extend flagging based on time:
            default: ''= no time based extension
            example:
            extendant = 'all'
     subplot -- Panel number on the display screen
            default: 111 (full screen display); example:
            if iteration is non-blank, then
               subplot=yx1 window will produce y by x plots in the window.
            if iteration = '', then
               subplot=yxn; means the window will have y rows, and x columns
               with the present execution placing the plot in location n
               n = 1,..., xy, in order upper left to right, then down.  An
               example is the plotting of four fields on one frame
               field='0'; subplot=221; plotxy()
               field='1'; subplot=222; plotxy()
               field='2'; subplot=223; plotxy()
               field='3'; subplot=224; plotxy()
     overplot -- Overplot on current plot (if possible)
            default: False; example: overplot= True
     showflags -- Show the flagged and unflagged data.
            default: False; example: showflags=True
     iteration -- Iterate plots:
            default: ''; no iteration
            Options: 'field', 'antenna', 'baseline'.
            Use the 'NEXT' button on gui to iterate through values.
            To abort an iteration, close the gui window.
     plotsymbol -- plot symbol. (Options include .:,o^v><s+xDd234hH|_ or
                   optionally preceded by one of color code k, r, g, b, c, y) 
            default: '.': points, medium-sized dots
            example: plotsymbol='bo' (blue points, large-sized dots
              r=red, b=blue, g=green, y=yellow
              ',' = small points
              '.' = medium points
              'o' = large points
     plotcolor -- color.  Overrides plotsymbol color settings.
            default: 'darkcyan'
            example: plotcolor='g' (green)
                     plotcolor='slateblue'
                     plotcolor='#7FFF34' (RGB tuple)
     multicolor -- Multi-color plotting of channels and correlations
             options: 'none','both','chan','corr'
             default: 'corr'; example: multicolor='chan'
     plotrange -- Specifies the size of the plot [xmin, xmax, ymin, ymax]
            default: [0,0,0,0];  Range is self-selected
	    example: [0,0,0.00,0.20]  only y axis is specified 
            To use a time range (NOTE: somewhat different sytax from timerange
	       ['22:23:24, 23:42:20', 0.02, 0.20]
	       The day must be included if the visibility data span more than one day
	       ['1997/05/09/22:02:00, 1997/05/09/23:00:00', 0.02, 0.20]
     selectplot -- Additional plot control parameters
            default: False; example: selectplot=true
       >>> selectplot expandable parameters
         markersize -- Size of the plotted marks
            default: 5.0; example: markersize=10.0
         linewidth -- Width of plotted lines.
            default: 1; example: linewidth=2.0
         skipnrows -- # of points to skip
            default: 0
            example: skipnrows=100 (plots every 100th point)
         newplot -- When overplotting, replace the last plot only
            default: False; can be useful when doing subplots
	 clearpanel -- Clear nothing on the plot window, automatically
	          clear plotting area, clear the current plot area, or
	          clear the whole plot panel.
	       options: None, Auto, Current, All
	       default: Auto
	       example: clearpanel='Current'
	 title -- Plot title (above plot)
            default: ''; example: title='This is my title'
         xlabels -- Label for x axis
            default: ''; example: xlabels='X Axis'
         ylabels -- Label for y axis
            default: ''; example: ylabels='Y Axis'
         fontsize -- Font size for labels
            default: 10; example: fontsize=2
         windowsize -- Window size
            default: 1.0; not yet implemented
         interactive -- turn on/off on screen display
            options: True = interactively flag data
                     False = direct output to a file without on screen display
            default: True;
	 figfile -- File name to save the plotted figure to.
	    default: '' = do not save figure; 
            example: figfile='myPlot.png' save figure to png file
                     figfile='myPlot.txt' append plotted xy to an ascii file
	 end -- File name to save the plotted figure to.
	    default: False = do not quit, keep plotting; 
            example: end=True no more plotting to do

         Hints on using plotxy (see section 3.4 in cookbook)

         Useful Buttons at bottom left:
              5th--magnifying glass.  Click on this,
                       left mouse button rectangle drag will zoom
                       right mose button rectangle drag will unzoom a certain amount
              1st--restore original magnification

         Useful regions just above:
              Quit will terminate plotter
              Next will go to next plot as specified by iteration
              To flag, unflag, locate, you must click 'Mark Region' first
                 then make appropriate region(s)
                 then click flag, unflag, locate for the desired operation
                 plot will then refrest
            
 
        """
	if not hasattr(self, "__globals__") or self.__globals__ == None :
           self.__globals__=sys._getframe(len(inspect.stack())-1).f_globals
	#casac = self.__globals__['casac']
	casalog = self.__globals__['casalog']
	#casalog = casac.casac.logsink()
        self.__globals__['__last_task'] = 'plotxy'
        self.__globals__['taskname'] = 'plotxy'
        ###
        self.__globals__['update_params'](func=self.__globals__['taskname'],printtext=False,ipython_globals=self.__globals__)
        ###
        ###
        #Handle globals or user over-ride of arguments
        #
	function_signature_defaults=dict(zip(self.__call__.func_code.co_varnames,self.__call__.func_defaults))
	useLocalDefaults = False

        for item in function_signature_defaults.iteritems():
                key,val = item
                keyVal = eval(key)
                if (keyVal == None):
                        #user hasn't set it - use global/default
                        pass
                else:
                        #user has set it - use over-ride
			if (key != 'self') :
			   useLocalDefaults = True

	myparams = {}
	if useLocalDefaults :
	   for item in function_signature_defaults.iteritems():
	       key,val = item
	       keyVal = eval(key)
	       exec('myparams[key] = keyVal')
	       self.parameters[key] = keyVal
	       if (keyVal == None):
	           exec('myparams[key] = '+ key + ' = self.itsdefault(key)')
		   keyVal = eval(key)
		   if(type(keyVal) == dict) :
                      if len(keyVal) > 0 :
		         exec('myparams[key] = ' + key + ' = keyVal[len(keyVal)-1][\'value\']')
		      else :
		         exec('myparams[key] = ' + key + ' = {}')

	else :
            async = self.parameters['async']
            myparams['vis'] = vis = self.parameters['vis']
            myparams['xaxis'] = xaxis = self.parameters['xaxis']
            myparams['yaxis'] = yaxis = self.parameters['yaxis']
            myparams['datacolumn'] = datacolumn = self.parameters['datacolumn']
            myparams['iteration'] = iteration = self.parameters['iteration']
            myparams['selectdata'] = selectdata = self.parameters['selectdata']
            myparams['antenna'] = antenna = self.parameters['antenna']
            myparams['spw'] = spw = self.parameters['spw']
            myparams['field'] = field = self.parameters['field']
            myparams['uvrange'] = uvrange = self.parameters['uvrange']
            myparams['timerange'] = timerange = self.parameters['timerange']
            myparams['correlation'] = correlation = self.parameters['correlation']
            myparams['scan'] = scan = self.parameters['scan']
            myparams['feed'] = feed = self.parameters['feed']
            myparams['array'] = array = self.parameters['array']
            myparams['averagemode'] = averagemode = self.parameters['averagemode']
            myparams['width'] = width = self.parameters['width']
            myparams['timebin'] = timebin = self.parameters['timebin']
            myparams['crossscans'] = crossscans = self.parameters['crossscans']
            myparams['crossbls'] = crossbls = self.parameters['crossbls']
            myparams['crossarrays'] = crossarrays = self.parameters['crossarrays']
            myparams['stackspw'] = stackspw = self.parameters['stackspw']
            myparams['restfreq'] = restfreq = self.parameters['restfreq']
            myparams['frame'] = frame = self.parameters['frame']
            myparams['doppler'] = doppler = self.parameters['doppler']
            myparams['extendflag'] = extendflag = self.parameters['extendflag']
            myparams['extendcorr'] = extendcorr = self.parameters['extendcorr']
            myparams['extendchan'] = extendchan = self.parameters['extendchan']
            myparams['extendspw'] = extendspw = self.parameters['extendspw']
            myparams['extendant'] = extendant = self.parameters['extendant']
            myparams['extendtime'] = extendtime = self.parameters['extendtime']
            myparams['subplot'] = subplot = self.parameters['subplot']
            myparams['plotsymbol'] = plotsymbol = self.parameters['plotsymbol']
            myparams['plotcolor'] = plotcolor = self.parameters['plotcolor']
            myparams['markersize'] = markersize = self.parameters['markersize']
            myparams['linewidth'] = linewidth = self.parameters['linewidth']
            myparams['plotrange'] = plotrange = self.parameters['plotrange']
            myparams['multicolor'] = multicolor = self.parameters['multicolor']
            myparams['selectplot'] = selectplot = self.parameters['selectplot']
            myparams['overplot'] = overplot = self.parameters['overplot']
            myparams['newplot'] = newplot = self.parameters['newplot']
            myparams['clearpanel'] = clearpanel = self.parameters['clearpanel']
            myparams['skipnrows'] = skipnrows = self.parameters['skipnrows']
            myparams['title'] = title = self.parameters['title']
            myparams['xlabels'] = xlabels = self.parameters['xlabels']
            myparams['ylabels'] = ylabels = self.parameters['ylabels']
            myparams['fontsize'] = fontsize = self.parameters['fontsize']
            myparams['windowsize'] = windowsize = self.parameters['windowsize']
            myparams['showflags'] = showflags = self.parameters['showflags']
            myparams['interactive'] = interactive = self.parameters['interactive']
            myparams['figfile'] = figfile = self.parameters['figfile']
            myparams['end'] = end = self.parameters['end']


	result = None

#
#    The following is work around to avoid a bug with current python translation
#
        mytmp = {}

        mytmp['vis'] = vis
        mytmp['xaxis'] = xaxis
        mytmp['yaxis'] = yaxis
        mytmp['datacolumn'] = datacolumn
        mytmp['iteration'] = iteration
        mytmp['selectdata'] = selectdata
        mytmp['antenna'] = antenna
        mytmp['spw'] = spw
        mytmp['field'] = field
        mytmp['uvrange'] = uvrange
        mytmp['timerange'] = timerange
        mytmp['correlation'] = correlation
        mytmp['scan'] = scan
        mytmp['feed'] = feed
        mytmp['array'] = array
        mytmp['averagemode'] = averagemode
        mytmp['width'] = width
        mytmp['timebin'] = timebin
        mytmp['crossscans'] = crossscans
        mytmp['crossbls'] = crossbls
        mytmp['crossarrays'] = crossarrays
        mytmp['stackspw'] = stackspw
        mytmp['restfreq'] = restfreq
        mytmp['frame'] = frame
        mytmp['doppler'] = doppler
        mytmp['extendflag'] = extendflag
        mytmp['extendcorr'] = extendcorr
        mytmp['extendchan'] = extendchan
        mytmp['extendspw'] = extendspw
        mytmp['extendant'] = extendant
        mytmp['extendtime'] = extendtime
        mytmp['subplot'] = subplot
        mytmp['plotsymbol'] = plotsymbol
        mytmp['plotcolor'] = plotcolor
        mytmp['markersize'] = markersize
        mytmp['linewidth'] = linewidth
        mytmp['plotrange'] = plotrange
        mytmp['multicolor'] = multicolor
        mytmp['selectplot'] = selectplot
        mytmp['overplot'] = overplot
        mytmp['newplot'] = newplot
        mytmp['clearpanel'] = clearpanel
        mytmp['skipnrows'] = skipnrows
        mytmp['title'] = title
        mytmp['xlabels'] = xlabels
        mytmp['ylabels'] = ylabels
        mytmp['fontsize'] = fontsize
        mytmp['windowsize'] = windowsize
        mytmp['showflags'] = showflags
        mytmp['interactive'] = interactive
        mytmp['figfile'] = figfile
        mytmp['end'] = end
	#
	# This task is never suppose to use the task manager to run async
	#
        async=False
	pathname='file:///'+os.environ.get('CASAPATH').split()[0]+'/xml/'
        trec = casac.casac.utils().torecord(pathname+'plotxy.xml')

        casalog.origin('plotxy')
	try :
          #if not trec.has_key('plotxy') or not casac.casac.utils().verify(mytmp, trec['plotxy']) :
	    #return False

          casac.casac.utils().verify(mytmp, trec['plotxy'], True)
          scriptstr=['']
          saveinputs = self.__globals__['saveinputs']
          saveinputs('plotxy', 'plotxy.last', myparams, self.__globals__,scriptstr=scriptstr)
          if async :
	    count = 0
	    keybase =  time.strftime("%y%m%d.%H%M%S")
	    key = keybase + "_" + str(count)
	    while self.__async__.has_key(key) :
	       count += 1
	       key = keybase + "_" + str(count)
            result = tm.execute('plotxy', vis, xaxis, yaxis, datacolumn, iteration, selectdata, antenna, spw, field, uvrange, timerange, correlation, scan, feed, array, averagemode, width, timebin, crossscans, crossbls, crossarrays, stackspw, restfreq, frame, doppler, extendflag, extendcorr, extendchan, extendspw, extendant, extendtime, subplot, plotsymbol, plotcolor, markersize, linewidth, plotrange, multicolor, selectplot, overplot, newplot, clearpanel, skipnrows, title, xlabels, ylabels, fontsize, windowsize, showflags, interactive, figfile, end)
	    print "Use: "
	    print "      tm.retrieve(return_value) # to retrieve the status"
	    print 
	    self.rkey = key
	    self.__async__[key] = result
          else :
              tname = 'plotxy'
              spaces = ' '*(18-len(tname))
              casalog.post('\n##########################################'+
                           '\n##### Begin Task: ' + tname + spaces + ' #####')
              casalog.post(scriptstr[1][1:]+'\n', 'INFO')
              result = plotxy(vis, xaxis, yaxis, datacolumn, iteration, selectdata, antenna, spw, field, uvrange, timerange, correlation, scan, feed, array, averagemode, width, timebin, crossscans, crossbls, crossarrays, stackspw, restfreq, frame, doppler, extendflag, extendcorr, extendchan, extendspw, extendant, extendtime, subplot, plotsymbol, plotcolor, markersize, linewidth, plotrange, multicolor, selectplot, overplot, newplot, clearpanel, skipnrows, title, xlabels, ylabels, fontsize, windowsize, showflags, interactive, figfile, end)
              casalog.post('##### End Task: ' + tname + '  ' + spaces + ' #####'+
                           '\n##########################################')

	except Exception, instance:
          if(self.__globals__.has_key('__rethrow_casa_exceptions') and self.__globals__['__rethrow_casa_exceptions']) :
             raise
          else :
             #print '**** Error **** ',instance
	     tname = 'plotxy'
             casalog.post('An error occurred running task '+tname+'.', 'ERROR')
             pass

        gc.collect()
        return result
#
#
#
    def paramgui(self, useGlobals=True, ipython_globals=None):
        """
        Opens a parameter GUI for this task.  If useGlobals is true, then any relevant global parameter settings are used.
        """
        import paramgui
	if not hasattr(self, "__globals__") or self.__globals__ == None :
           self.__globals__=sys._getframe(len(inspect.stack())-1).f_globals

        if useGlobals:
	    if ipython_globals == None:
                myf=self.__globals__
            else:
                myf=ipython_globals

            paramgui.setGlobals(myf)
        else:
            paramgui.setGlobals({})

        paramgui.runTask('plotxy', myf['_ip'])
        paramgui.setGlobals({})

#
#
#
    def defaults(self, param=None, ipython_globals=None, paramvalue=None, subparam=None):
	if not hasattr(self, "__globals__") or self.__globals__ == None :
           self.__globals__=sys._getframe(len(inspect.stack())-1).f_globals
        if ipython_globals == None:
            myf=self.__globals__
        else:
            myf=ipython_globals

        a = odict()
        a['vis']  = ''
        a['xaxis']  = 'time'
        a['yaxis']  = 'amp'
        a['iteration']  = ''
        a['selectdata']  = True
        a['spw']  = ''
        a['field']  = ''
        a['averagemode']  = ''
        a['restfreq']  = ''
        a['extendflag']  = False
        a['subplot']  = 111
        a['plotsymbol']  = '.'
        a['plotcolor']  = 'darkcyn'
        a['plotrange']  = [-1, -1, -1, -1]
        a['multicolor']  = 'corr'
        a['selectplot']  = False
        a['overplot']  = False
        a['showflags']  = False
        a['interactive']  = True
        a['figfile']  = ''
        a['end']  = False

        a['async']=False
        a['yaxis'] = {
                    0:odict([{'value':'amp'}, {'datacolumn':'data'}]), 
                    1:odict([{'value':'phase'}, {'datacolumn':'data'}]), 
                    2:odict([{'value':'imag'}, {'datacolumn':'data'}]), 
                    3:odict([{'value':'real'}, {'datacolumn':'data'}]), 
                    4:{'value':'time'}, 
                    5:{'value':'uvdist'}, 
                    6:{'value':'chan'}, 
                    7:{'value':'corr'}, 
                    8:{'value':'freq'}, 
                    9:{'value':'velo'}, 
                    10:{'value':'u'}, 
                    11:{'value':'v'}, 
                    12:{'value':'w'}, 
                    13:{'value':'azimuth'}, 
                    14:{'value':'elevation'}, 
                    15:{'value':'baseline'}, 
                    16:{'value':'hourangle'}, 
                    17:{'value':'parallacticangle'}, 
                    18:{'value':'weight'}}
        a['selectdata'] = {
                    0:odict([{'value':True}, {'antenna':''}, {'timerange':''}, {'correlation':''}, {'scan':''}, {'feed':''}, {'array':''}, {'uvrange':''}]), 
                    1:{'value':False}}
        a['averagemode'] = {
                    0:{'value':''}, 
                    1:odict([{'value':'vector'}, {'timebin':'0'}, {'crossscans':False}, {'crossbls':False}, {'crossarrays':False}, {'stackspw':False}, {'width':'1'}]), 
                    2:odict([{'value':'scalar'}, {'timebin':'0'}, {'crossscans':False}, {'crossbls':False}, {'crossarrays':False}, {'stackspw':False}, {'width':'1'}])}
        a['restfreq'] = {
                    0:odict([{'notvalue':''}, {'frame':'LSRK'}, {'doppler':'RADIO'}])}
        a['extendflag'] = {
                    0:{'value':False}, 
                    1:odict([{'value':True}, {'extendcorr':''}, {'extendchan':''}, {'extendspw':''}, {'extendant':''}, {'extendtime':''}])}
        a['selectplot'] = {
                    0:{'value':False}, 
                    1:odict([{'value':True}, {'markersize':5.0}, {'linewidth':1.0}, {'skipnrows':1}, {'newplot':False}, {'clearpanel':'Auto'}, {'title':''}, {'xlabels':''}, {'ylabels':''}, {'fontsize':10.0}, {'windowsize':5.0}])}

### This function sets the default values but also will return the list of
### parameters or the default value of a given parameter
        if(param == None):
                myf['__set_default_parameters'](a)
        elif(param == 'paramkeys'):
                return a.keys()
        else:
            if(paramvalue==None and subparam==None):
               if(a.has_key(param)):
                  return a[param]
               else:
                  return self.itsdefault(param)
            else:
               retval=a[param]
               if(type(a[param])==dict):
                  for k in range(len(a[param])):
                     valornotval='value'
                     if(a[param][k].has_key('notvalue')):
                        valornotval='notvalue'
                     if((a[param][k][valornotval])==paramvalue):
                        retval=a[param][k].copy()
                        retval.pop(valornotval)
                        if(subparam != None):
                           if(retval.has_key(subparam)):
                              retval=retval[subparam]
                           else:
                              retval=self.itsdefault(subparam)
		     else:
                        retval=self.itsdefault(subparam)
               return retval


#
#
    def check_params(self, param=None, value=None, ipython_globals=None):
      if ipython_globals == None:
          myf=self.__globals__
      else:
          myf=ipython_globals
#      print 'param:', param, 'value:', value
      try :
         if str(type(value)) != "<type 'instance'>" :
            value0 = value
            value = myf['cu'].expandparam(param, value)
            matchtype = False
            if(type(value) == numpy.ndarray):
               if(type(value) == type(value0)):
                  myf[param] = value.tolist()
               else:
                  #print 'value:', value, 'value0:', value0
                  #print 'type(value):', type(value), 'type(value0):', type(value0)
                  myf[param] = value0
                  if type(value0) != list :
                     matchtype = True
            else :
               myf[param] = value
            value = myf['cu'].verifyparam({param:value})
            if matchtype:
               value = False
      except Exception, instance:
         #ignore the exception and just return it unchecked
         myf[param] = value
      return value
#
#
    def description(self, key='plotxy', subkey=None):
        desc={'plotxy': 'An X-Y plotter/interactive flagger for visibility data.',
               'vis': 'Name of input visibility dataset',
               'xaxis': 'X-axis: def = \'time\': see help for options',
               'yaxis': 'Y-axis: def = \'amp\': see help for options',
               'datacolumn': 'data (raw), corrected, model, residual (corrected - model)',
               'iteration': 'Plot separate panels by field, antenna, baseline, scan, feed',
               'selectdata': 'More data selection parameters (antenna, timerange etc)',
               'antenna': 'antenna/baselines: \'\'==>all, antenna = \'3,VA04\'',
               'spw': 'Spectral windows:channels: \'\'==>all, spw=\'2:5~57\'',
               'field': 'Field names or field index numbers: \'\'==>all, field=\'0~2,3C286\'',
               'uvrange': 'uv range: \'\'==>all; uvrange = \'0~100klambda\'',
               'timerange': 'time range: \'\'==>all, timerange=\'09:14:0~09:54:0\'',
               'correlation': 'correlations: \'\'==>all, correlations=\'RR LL\'',
               'scan': 'scan numbers: \'\'==>all',
               'feed': 'multi-feed numbers: Not yet implemented',
               'array': '(sub)array numbers: \'\'==>all',
               'averagemode': 'Select averaging type: \'vector\', \'scalar\'',
               'width': 'number of channels to average, default: \'1\', Also: \'all\', \'allspw\'',
               'timebin': 'Averaging time in seconds, default=\'0\', also: \'all\'',
               'crossscans': 'have time averaging cross over scans?',
               'crossbls': 'have averaging cross over baselines?',
               'crossarrays': 'have averaging cross over arrays?',
               'stackspw': 'stack multiple spw on top of each other?',
               'restfreq': 'a frequency quanta or transition name. see help for options',
               'frame': 'frequency frame for spectral axis. see help for options',
               'doppler': 'doppler mode. see help for options',
               'extendflag': 'have flagging extend to other data points?',
               'extendcorr': 'extend flags based on correlation: \'\'==> selectdata,\'half\', or \'all\' ',
               'extendchan': 'extend flags based on channel: \'\'==> selectdata or \'all\'',
               'extendspw': 'extend flags based on spw: \'\'==> selectdata or \'all\'',
               'extendant': 'extend flags based on antenna: \'\'==> selectdata or \'all\'',
               'extendtime': 'extend flags based on time: \'\'==> selectdata or \'all\'',
               'subplot': 'Multipanel display scheme (yxn)',
               'plotsymbol': 'Options include . : , o ^ v > < s + x D d 2 3 4 h H | _',
               'plotcolor': 'Plot color',
               'markersize': 'Size of plotted marks',
               'linewidth': 'Width of plotted lines',
               'plotrange': 'The range of data to be plotted (see help)',
               'multicolor': 'Plot in different colors: Options: none, both, chan, corr',
               'selectplot': 'Select additional plotting options (e.g, fontsize, title,etc)',
               'overplot': 'Overplot on current plot (if possible)',
               'newplot': 'Replace the last plot or not when overplotting',
               'clearpanel': 'Specify if old plots are cleared or not',
               'skipnrows': 'Plot every nth point',
               'title': 'Plot title (above plot)',
               'xlabels': 'Label for x-axis',
               'ylabels': 'Label for y-axis',
               'fontsize': 'Font size for labels',
               'windowsize': 'Window size: not yet implemented',
               'showflags': 'Show flagged data?',
               'interactive': 'Show plot on gui?',
               'figfile': '\'\'= no plot hardcopy, otherwise supply name',
               'end': 'Quit plotting?',

               'async': 'If true the taskname must be started using plotxy(...)'
              }

#
# Set subfields defaults if needed
#

        if(desc.has_key(key)) :
           return desc[key]

    def itsdefault(self, paramname) :
        a = {}
        a['vis']  = ''
        a['xaxis']  = 'time'
        a['yaxis']  = 'amp'
        a['datacolumn']  = 'data'
        a['iteration']  = ''
        a['selectdata']  = True
        a['antenna']  = ''
        a['spw']  = ''
        a['field']  = ''
        a['uvrange']  = ''
        a['timerange']  = ''
        a['correlation']  = ''
        a['scan']  = ''
        a['feed']  = ''
        a['array']  = ''
        a['averagemode']  = ''
        a['width']  = '1'
        a['timebin']  = '0'
        a['crossscans']  = False
        a['crossbls']  = False
        a['crossarrays']  = False
        a['stackspw']  = False
        a['restfreq']  = ''
        a['frame']  = ''
        a['doppler']  = ''
        a['extendflag']  = False
        a['extendcorr']  = ''
        a['extendchan']  = ''
        a['extendspw']  = ''
        a['extendant']  = ''
        a['extendtime']  = ''
        a['subplot']  = 111
        a['plotsymbol']  = '.'
        a['plotcolor']  = 'darkcyn'
        a['markersize']  = 5.0
        a['linewidth']  = 1.0
        a['plotrange']  = [-1, -1, -1, -1]
        a['multicolor']  = 'corr'
        a['selectplot']  = False
        a['overplot']  = False
        a['newplot']  = False
        a['clearpanel']  = 'Auto'
        a['skipnrows']  = 0
        a['title']  = ''
        a['xlabels']  = ''
        a['ylabels']  = ''
        a['fontsize']  = 10.0
        a['windowsize']  = 1.0
        a['showflags']  = False
        a['interactive']  = True
        a['figfile']  = ''
        a['end']  = False

        #a = sys._getframe(len(inspect.stack())-1).f_globals

        if self.parameters['yaxis']  == 'amp':
            a['datacolumn'] = 'data'

        if self.parameters['yaxis']  == 'phase':
            a['datacolumn'] = 'data'

        if self.parameters['yaxis']  == 'imag':
            a['datacolumn'] = 'data'

        if self.parameters['yaxis']  == 'real':
            a['datacolumn'] = 'data'

        if self.parameters['selectdata']  == True:
            a['antenna'] = ''
            a['timerange'] = ''
            a['correlation'] = ''
            a['scan'] = ''
            a['feed'] = ''
            a['array'] = ''
            a['uvrange'] = ''

        if self.parameters['averagemode']  == 'vector':
            a['timebin'] = '0'
            a['crossscans'] = False
            a['crossbls'] = False
            a['crossarrays'] = False
            a['stackspw'] = False
            a['width'] = '1'

        if self.parameters['averagemode']  == 'scalar':
            a['timebin'] = '0'
            a['crossscans'] = False
            a['crossbls'] = False
            a['crossarrays'] = False
            a['stackspw'] = False
            a['width'] = '1'

        if self.parameters['restfreq']  != '':
            a['frame'] = 'LSRK'
            a['doppler'] = 'RADIO'

        if self.parameters['extendflag']  == True:
            a['extendcorr'] = ''
            a['extendchan'] = ''
            a['extendspw'] = ''
            a['extendant'] = ''
            a['extendtime'] = ''

        if self.parameters['selectplot']  == True:
            a['markersize'] = 5.0
            a['linewidth'] = 1.0
            a['skipnrows'] = 1
            a['newplot'] = False
            a['clearpanel'] = 'Auto'
            a['title'] = ''
            a['xlabels'] = ''
            a['ylabels'] = ''
            a['fontsize'] = 10.0
            a['windowsize'] = 5.0

        if a.has_key(paramname) :
	      return a[paramname]
plotxy_cli = plotxy_cli_()
