#
# This file was generated using xslt from its XML file
#
# Copyright 2013, Associated Universities Inc., Washington DC
#
import sys
import os
#from casac import *
import casac
import string
import time
import inspect
import gc
import numpy
from odict import odict
from taskmanager import tm
from task_tclean import tclean
class tclean_cli_:
    __name__ = "tclean"
    __async__ = {}
    rkey = None
    i_am_a_casapy_task = None
    # The existence of the i_am_a_casapy_task attribute allows help()
    # (and other) to treat casapy tasks as a special case.

    def __init__(self) :
       self.__bases__ = (tclean_cli_,)
       self.__doc__ = self.__call__.__doc__

       self.parameters={'vis':None, 'field':None, 'spw':None, 'outlierfile':None, 'imagename':None, 'nchan':None, 'imsize':None, 'ftmachine':None, 'startmodel':None, 'algo':None, 'niter':None, 'cycleniter':None, 'cyclefactor':None, 'minpsffraction':None, 'maxpsffraction':None, 'threshold':None, 'loopgain':None, 'usescratch':None, 'interactive':None, 'clusterdef':None,  'async':None}


    def result(self, key=None):
	    #### here we will scan the task-ids in __async__
	    #### and add any that have completed...
	    if key is not None and self.__async__.has_key(key) and self.__async__[key] is not None:
	       ret = tm.retrieve(self.__async__[key])
	       if ret['state'] == "done" :
	          self.__async__[key] = None
	       elif ret['state'] == 'crashed' :
		  self.__async__[key] = None
	       return ret
	    return None


    def __call__(self, vis=None, field=None, spw=None, outlierfile=None, imagename=None, nchan=None, imsize=None, ftmachine=None, startmodel=None, algo=None, niter=None, cycleniter=None, cyclefactor=None, minpsffraction=None, maxpsffraction=None, threshold=None, loopgain=None, usescratch=None, interactive=None, clusterdef=None,  async=None):

        """Construct and deconvolve images

	Detailed Description: 
Form images from visibilities. Handles continuum and spectral line cubes.
	Arguments :
		vis:	Name of input visibility file(s)
		   Default Value: 

		field:	field(s) to select
		   Default Value: 

		spw:	spw(s) to select
		   Default Value: 

		outlierfile:	Name of outlier-field image definitions
		   Default Value: 

		imagename:	Pre-name of output images
		   Default Value: 

		nchan:	Number of channels in the output image
		   Default Value: 1

		imsize:	Number of pixels
		   Default Value: 1,1

		ftmachine:	Name of FT machine during gridding
		   Default Value: ft

		startmodel:	Name of starting model image
		   Default Value: 

		algo:	Name of minor cycle algorithm
		   Default Value: test

		niter:	Maximum number of iterations
		   Default Value: 500

		cycleniter:	Maximum number of minor-cycle iterations before triggering a major cycle
		   Default Value: -1

		cyclefactor:	Scaling on PSF sidelobe level to compute the minor-cycle stopping threshold.
		   Default Value: 1.0

		minpsffraction:	PSF fraction that marks the max depth of cleaning in the minor cycle 
		   Default Value: 0.05

		maxpsffraction:	PSF fraction that marks the minimum depth of cleaning in the minor cycle 
		   Default Value: 0.8

		threshold:	Stopping threshold (number, in units of Jy)
		   Default Value: 0.0

		loopgain:	Loop gain
		   Default Value: 0.1

		usescratch:	True if to save model visibilities in MODEL_DATA column
		   Default Value: False

		interactive:	True to be able to modify masks and parameters at runtime
		   Default Value: False

		clusterdef:	Name of a file that contains the cluster definition
		   Default Value: 

	Returns: void

	Example :


       This is an empty task. 
       It is meant only to build/test/maintain the interface for the refactored imaging code. 
       When ready, it will be offered to users for testing.

  
        """
	if not hasattr(self, "__globals__") or self.__globals__ == None :
           self.__globals__=sys._getframe(len(inspect.stack())-1).f_globals
	#casac = self.__globals__['casac']
	casalog = self.__globals__['casalog']
	#casalog = casac.casac.logsink()
        self.__globals__['__last_task'] = 'tclean'
        self.__globals__['taskname'] = 'tclean'
        ###
        self.__globals__['update_params'](func=self.__globals__['taskname'],printtext=False,ipython_globals=self.__globals__)
        ###
        ###
        #Handle globals or user over-ride of arguments
        #
	function_signature_defaults=dict(zip(self.__call__.func_code.co_varnames,self.__call__.func_defaults))
	useLocalDefaults = False

        for item in function_signature_defaults.iteritems():
                key,val = item
                keyVal = eval(key)
                if (keyVal == None):
                        #user hasn't set it - use global/default
                        pass
                else:
                        #user has set it - use over-ride
			if (key != 'self') :
			   useLocalDefaults = True

	myparams = {}
	if useLocalDefaults :
	   for item in function_signature_defaults.iteritems():
	       key,val = item
	       keyVal = eval(key)
	       exec('myparams[key] = keyVal')
	       self.parameters[key] = keyVal
	       if (keyVal == None):
	           exec('myparams[key] = '+ key + ' = self.itsdefault(key)')
		   keyVal = eval(key)
		   if(type(keyVal) == dict) :
                      if len(keyVal) > 0 :
		         exec('myparams[key] = ' + key + ' = keyVal[len(keyVal)-1][\'value\']')
		      else :
		         exec('myparams[key] = ' + key + ' = {}')

	else :
            async = self.parameters['async']
            myparams['vis'] = vis = self.parameters['vis']
            myparams['field'] = field = self.parameters['field']
            myparams['spw'] = spw = self.parameters['spw']
            myparams['outlierfile'] = outlierfile = self.parameters['outlierfile']
            myparams['imagename'] = imagename = self.parameters['imagename']
            myparams['nchan'] = nchan = self.parameters['nchan']
            myparams['imsize'] = imsize = self.parameters['imsize']
            myparams['ftmachine'] = ftmachine = self.parameters['ftmachine']
            myparams['startmodel'] = startmodel = self.parameters['startmodel']
            myparams['algo'] = algo = self.parameters['algo']
            myparams['niter'] = niter = self.parameters['niter']
            myparams['cycleniter'] = cycleniter = self.parameters['cycleniter']
            myparams['cyclefactor'] = cyclefactor = self.parameters['cyclefactor']
            myparams['minpsffraction'] = minpsffraction = self.parameters['minpsffraction']
            myparams['maxpsffraction'] = maxpsffraction = self.parameters['maxpsffraction']
            myparams['threshold'] = threshold = self.parameters['threshold']
            myparams['loopgain'] = loopgain = self.parameters['loopgain']
            myparams['usescratch'] = usescratch = self.parameters['usescratch']
            myparams['interactive'] = interactive = self.parameters['interactive']
            myparams['clusterdef'] = clusterdef = self.parameters['clusterdef']


	result = None

#
#    The following is work around to avoid a bug with current python translation
#
        mytmp = {}

        mytmp['vis'] = vis
        mytmp['field'] = field
        mytmp['spw'] = spw
        mytmp['outlierfile'] = outlierfile
        mytmp['imagename'] = imagename
        mytmp['nchan'] = nchan
        mytmp['imsize'] = imsize
        mytmp['ftmachine'] = ftmachine
        mytmp['startmodel'] = startmodel
        mytmp['algo'] = algo
        mytmp['niter'] = niter
        mytmp['cycleniter'] = cycleniter
        mytmp['cyclefactor'] = cyclefactor
        mytmp['minpsffraction'] = minpsffraction
        mytmp['maxpsffraction'] = maxpsffraction
        mytmp['threshold'] = threshold
        mytmp['loopgain'] = loopgain
        mytmp['usescratch'] = usescratch
        mytmp['interactive'] = interactive
        mytmp['clusterdef'] = clusterdef
	pathname='file:///'+os.environ.get('CASAPATH').split()[0]+'/xml/'
        trec = casac.casac.utils().torecord(pathname+'tclean.xml')

        casalog.origin('tclean')
	try :
          #if not trec.has_key('tclean') or not casac.casac.utils().verify(mytmp, trec['tclean']) :
	    #return False

          casac.casac.utils().verify(mytmp, trec['tclean'], True)
          scriptstr=['']
          saveinputs = self.__globals__['saveinputs']
          saveinputs('tclean', 'tclean.last', myparams, self.__globals__,scriptstr=scriptstr)
          if async :
	    count = 0
	    keybase =  time.strftime("%y%m%d.%H%M%S")
	    key = keybase + "_" + str(count)
	    while self.__async__.has_key(key) :
	       count += 1
	       key = keybase + "_" + str(count)
            result = tm.execute('tclean', vis, field, spw, outlierfile, imagename, nchan, imsize, ftmachine, startmodel, algo, niter, cycleniter, cyclefactor, minpsffraction, maxpsffraction, threshold, loopgain, usescratch, interactive, clusterdef)
	    print "Use: "
	    print "      tm.retrieve(return_value) # to retrieve the status"
	    print 
	    self.rkey = key
	    self.__async__[key] = result
          else :
              tname = 'tclean'
              spaces = ' '*(18-len(tname))
              casalog.post('\n##########################################'+
                           '\n##### Begin Task: ' + tname + spaces + ' #####')
              casalog.post(scriptstr[1][1:]+'\n', 'INFO')
              result = tclean(vis, field, spw, outlierfile, imagename, nchan, imsize, ftmachine, startmodel, algo, niter, cycleniter, cyclefactor, minpsffraction, maxpsffraction, threshold, loopgain, usescratch, interactive, clusterdef)
              casalog.post('##### End Task: ' + tname + '  ' + spaces + ' #####'+
                           '\n##########################################')

	except Exception, instance:
          if(self.__globals__.has_key('__rethrow_casa_exceptions') and self.__globals__['__rethrow_casa_exceptions']) :
             raise
          else :
             #print '**** Error **** ',instance
	     tname = 'tclean'
             casalog.post('An error occurred running task '+tname+'.', 'ERROR')
             pass

        gc.collect()
        return result
#
#
#
    def paramgui(self, useGlobals=True, ipython_globals=None):
        """
        Opens a parameter GUI for this task.  If useGlobals is true, then any relevant global parameter settings are used.
        """
        import paramgui
	if not hasattr(self, "__globals__") or self.__globals__ == None :
           self.__globals__=sys._getframe(len(inspect.stack())-1).f_globals

        if useGlobals:
	    if ipython_globals == None:
                myf=self.__globals__
            else:
                myf=ipython_globals

            paramgui.setGlobals(myf)
        else:
            paramgui.setGlobals({})

        paramgui.runTask('tclean', myf['_ip'])
        paramgui.setGlobals({})

#
#
#
    def defaults(self, param=None, ipython_globals=None, paramvalue=None, subparam=None):
	if not hasattr(self, "__globals__") or self.__globals__ == None :
           self.__globals__=sys._getframe(len(inspect.stack())-1).f_globals
        if ipython_globals == None:
            myf=self.__globals__
        else:
            myf=ipython_globals

        a = odict()
        a['vis']  = ''
        a['field']  = ''
        a['spw']  = ''
        a['outlierfile']  = ''
        a['imagename']  = ''
        a['nchan']  = 1
        a['imsize']  = [1,1]
        a['ftmachine']  = 'ft'
        a['startmodel']  = ''
        a['algo']  = 'test'
        a['niter']  = 500
        a['cycleniter']  = -1
        a['threshold']  = 0.0
        a['loopgain']  = 0.1
        a['usescratch']  = False
        a['interactive']  = False
        a['clusterdef']  = ''

        a['async']=False
        a['cycleniter'] = {
                    0:odict([{'notvalue':-1}, {'cyclefactor':1.0}, {'minpsffraction':0.05}, {'maxpsffraction':0.8}])}

### This function sets the default values but also will return the list of
### parameters or the default value of a given parameter
        if(param == None):
                myf['__set_default_parameters'](a)
        elif(param == 'paramkeys'):
                return a.keys()
        else:
            if(paramvalue==None and subparam==None):
               if(a.has_key(param)):
                  return a[param]
               else:
                  return self.itsdefault(param)
            else:
               retval=a[param]
               if(type(a[param])==dict):
                  for k in range(len(a[param])):
                     valornotval='value'
                     if(a[param][k].has_key('notvalue')):
                        valornotval='notvalue'
                     if((a[param][k][valornotval])==paramvalue):
                        retval=a[param][k].copy()
                        retval.pop(valornotval)
                        if(subparam != None):
                           if(retval.has_key(subparam)):
                              retval=retval[subparam]
                           else:
                              retval=self.itsdefault(subparam)
		     else:
                        retval=self.itsdefault(subparam)
               return retval


#
#
    def check_params(self, param=None, value=None, ipython_globals=None):
      if ipython_globals == None:
          myf=self.__globals__
      else:
          myf=ipython_globals
#      print 'param:', param, 'value:', value
      try :
         if str(type(value)) != "<type 'instance'>" :
            value0 = value
            value = myf['cu'].expandparam(param, value)
            matchtype = False
            if(type(value) == numpy.ndarray):
               if(type(value) == type(value0)):
                  myf[param] = value.tolist()
               else:
                  #print 'value:', value, 'value0:', value0
                  #print 'type(value):', type(value), 'type(value0):', type(value0)
                  myf[param] = value0
                  if type(value0) != list :
                     matchtype = True
            else :
               myf[param] = value
            value = myf['cu'].verifyparam({param:value})
            if matchtype:
               value = False
      except Exception, instance:
         #ignore the exception and just return it unchecked
         myf[param] = value
      return value
#
#
    def description(self, key='tclean', subkey=None):
        desc={'tclean': 'Construct and deconvolve images',
               'vis': 'Name of input visibility file(s)',
               'field': 'field(s) to select',
               'spw': 'spw(s) to select',
               'outlierfile': 'Name of outlier-field image definitions',
               'imagename': 'Pre-name of output images',
               'nchan': 'Number of channels in the output image',
               'imsize': 'Number of pixels',
               'ftmachine': 'Name of FT machine during gridding',
               'startmodel': 'Name of starting model image',
               'algo': 'Name of minor cycle algorithm',
               'niter': 'Maximum number of iterations',
               'cycleniter': 'Maximum number of minor-cycle iterations before triggering a major cycle',
               'cyclefactor': 'Scaling on PSF sidelobe level to compute the minor-cycle stopping threshold.',
               'minpsffraction': 'PSF fraction that marks the max depth of cleaning in the minor cycle ',
               'maxpsffraction': 'PSF fraction that marks the minimum depth of cleaning in the minor cycle ',
               'threshold': 'Stopping threshold (number, in units of Jy)',
               'loopgain': 'Loop gain',
               'usescratch': 'True if to save model visibilities in MODEL_DATA column',
               'interactive': 'True to be able to modify masks and parameters at runtime',
               'clusterdef': 'Name of a file that contains the cluster definition',

               'async': 'If true the taskname must be started using tclean(...)'
              }

#
# Set subfields defaults if needed
#

        if(desc.has_key(key)) :
           return desc[key]

    def itsdefault(self, paramname) :
        a = {}
        a['vis']  = ''
        a['field']  = ''
        a['spw']  = ''
        a['outlierfile']  = ''
        a['imagename']  = ''
        a['nchan']  = 1
        a['imsize']  = [1,1]
        a['ftmachine']  = 'ft'
        a['startmodel']  = ''
        a['algo']  = 'test'
        a['niter']  = 500
        a['cycleniter']  = -1
        a['cyclefactor']  = 1.0
        a['minpsffraction']  = 0.05
        a['maxpsffraction']  = 0.8
        a['threshold']  = 0.0
        a['loopgain']  = 0.1
        a['usescratch']  = False
        a['interactive']  = False
        a['clusterdef']  = ''

        #a = sys._getframe(len(inspect.stack())-1).f_globals

        if self.parameters['cycleniter']  != -1:
            a['cyclefactor'] = 1.0
            a['minpsffraction'] = 0.05
            a['maxpsffraction'] = 0.8

        if a.has_key(paramname) :
	      return a[paramname]
tclean_cli = tclean_cli_()
