#
# This file was generated using xslt from its XML file
#
# Copyright 2008, Associated Universities Inc., Washington DC
#
import sys
import os
from casac import *
import string
import time
import inspect
import gc
import numpy
from odict import odict
from task_tclean import tclean
from task_tclean import casalog

class tclean_pg_:
    __name__ = "tclean"

    def __init__(self) :
       self.__bases__ = (tclean_pg_,)
       self.__doc__ = self.__call__.__doc__


    def __call__(self, vis=None, field=None, spw=None, outlierfile=None, imagename=None, nchan=None, imsize=None, ftmachine=None, startmodel=None, algo=None, niter=None, cycleniter=None, cyclefactor=None, minpsffraction=None, maxpsffraction=None, threshold=None, loopgain=None, usescratch=None, interactive=None, clusterdef=None, async=None):

        """Construct and deconvolve images

       This is an empty task. 
       It is meant only to build/test/maintain the interface for the refactored imaging code. 
       When ready, it will be offered to users for testing.

  
        """
        a=inspect.stack()
        stacklevel=0
        for k in range(len(a)):
          if (string.find(a[k][1], 'ipython console') > 0) or (string.find(a[k][1], '<string>') >= 0):
                stacklevel=k
                break
        myf=sys._getframe(stacklevel).f_globals
        myf['__last_task'] = 'tclean'
        myf['taskname'] = 'tclean'
        ###
        myf['update_params'](func=myf['taskname'],printtext=False)
        ###
        ###
        #Handle globals or user over-ride of arguments
        #
	function_signature_defaults=dict(zip(self.__call__.func_code.co_varnames,self.__call__.func_defaults))
	useLocalDefaults = False

        for item in function_signature_defaults.iteritems():
                key,val = item
                keyVal = eval(key)
                if (keyVal == None):
                        #user hasn't set it - use global/default
                        pass
                else:
                        #user has set it - use over-ride
			if (key != 'self') :
			   useLocalDefaults = True
                        #myf[key]=keyVal

	myparams = {}
	if useLocalDefaults :
	   for item in function_signature_defaults.iteritems():
	       key,val = item
	       keyVal = eval(key)
	       exec('myparams[key] = keyVal')
	       if (keyVal == None):
	           exec('myparams[key] = '+ key + ' = self.itsdefault(key)')
		   keyVal = eval(key)
		   if(type(keyVal) == dict) :
		      exec('myparams[key] = ' + key + ' = keyVal[len(keyVal)-1][\'value\']')

	else :
            uselessvariable = None 
            myparams['vis'] = vis = myf['vis']
            myparams['field'] = field = myf['field']
            myparams['spw'] = spw = myf['spw']
            myparams['outlierfile'] = outlierfile = myf['outlierfile']
            myparams['imagename'] = imagename = myf['imagename']
            myparams['nchan'] = nchan = myf['nchan']
            myparams['imsize'] = imsize = myf['imsize']
            myparams['ftmachine'] = ftmachine = myf['ftmachine']
            myparams['startmodel'] = startmodel = myf['startmodel']
            myparams['algo'] = algo = myf['algo']
            myparams['niter'] = niter = myf['niter']
            myparams['cycleniter'] = cycleniter = myf['cycleniter']
            myparams['cyclefactor'] = cyclefactor = myf['cyclefactor']
            myparams['minpsffraction'] = minpsffraction = myf['minpsffraction']
            myparams['maxpsffraction'] = maxpsffraction = myf['maxpsffraction']
            myparams['threshold'] = threshold = myf['threshold']
            myparams['loopgain'] = loopgain = myf['loopgain']
            myparams['usescratch'] = usescratch = myf['usescratch']
            myparams['interactive'] = interactive = myf['interactive']
            myparams['clusterdef'] = clusterdef = myf['clusterdef']


	result = None

#
#    The following is work around to avoid a bug with current python translation
#
        mytmp = {}

        mytmp['vis'] = vis
        mytmp['field'] = field
        mytmp['spw'] = spw
        mytmp['outlierfile'] = outlierfile
        mytmp['imagename'] = imagename
        mytmp['nchan'] = nchan
        mytmp['imsize'] = imsize
        mytmp['ftmachine'] = ftmachine
        mytmp['startmodel'] = startmodel
        mytmp['algo'] = algo
        mytmp['niter'] = niter
        mytmp['cycleniter'] = cycleniter
        mytmp['cyclefactor'] = cyclefactor
        mytmp['minpsffraction'] = minpsffraction
        mytmp['maxpsffraction'] = maxpsffraction
        mytmp['threshold'] = threshold
        mytmp['loopgain'] = loopgain
        mytmp['usescratch'] = usescratch
        mytmp['interactive'] = interactive
        mytmp['clusterdef'] = clusterdef
	pathname='file:///'+os.environ.get('CASAPATH').split()[0]+'/xml/'
        trec = casac.utils().torecord(pathname+'tclean.xml')

        casalog.origin('tclean')
        if not trec.has_key('tclean') or not casac.utils().verify(mytmp, trec['tclean']) :
	    return False


	try :
          casalog.post('')
          casalog.post('##########################################')
          casalog.post('##### Begin Task: tclean           #####')
          casalog.post('')
          result = tclean(vis, field, spw, outlierfile, imagename, nchan, imsize, ftmachine, startmodel, algo, niter, cycleniter, cyclefactor, minpsffraction, maxpsffraction, threshold, loopgain, usescratch, interactive, clusterdef)
          casalog.post('')
          casalog.post('##### End Task: tclean           #####')
          casalog.post('##########################################')


# saveinputs for individule engine has no use
# saveinputs should alos be removed from casa_in_py.py
#
#
#          saveinputs = myf['saveinputs']
#          saveinputs('tclean', 'tclean.last', myparams)
#
#
	except Exception, instance:
	  if(myf.has_key('__rethrow_casa_exceptions') and myf['__rethrow_casa_exceptions']) :
	     raise
	  else:
	     tname = 'tclean'
	     casalog.post('An error occurred running task '+tname+'.', 'ERROR')
	     pass

        gc.collect()
        return result
#
#
##
#    def paramgui(self, useGlobals=True):
#        """
#        Opens a parameter GUI for this task.  If useGlobals is true, then any relevant global parameter settings are used.
#        """
#        import paramgui
#
#        a=inspect.stack()
#        stacklevel=0
#        for k in range(len(a)):
#          if (string.find(a[k][1], 'ipython console') > 0) or (string.find(a[k][1], '<string>') >= 0):
#            stacklevel=k
#            break
#        myf = sys._getframe(stacklevel).f_globals
#
#        if useGlobals:
#            paramgui.setGlobals(myf)
#        else:
#            paramgui.setGlobals({})
#
#        paramgui.runTask('tclean', myf['_ip'])
#        paramgui.setGlobals({})
#
#
#
#
    def defaults(self, param=None):
        a=inspect.stack()
        stacklevel=0
        for k in range(len(a)):
          if (string.find(a[k][1], 'ipython console') > 0) or (string.find(a[k][1], '<string>') >= 0):
                stacklevel=k
                break
        myf=sys._getframe(stacklevel).f_globals
        a = odict()
        a['vis']  = ''
        a['field']  = ''
        a['spw']  = ''
        a['outlierfile']  = ''
        a['imagename']  = ''
        a['nchan']  = 1
        a['imsize']  = [1,1]
        a['ftmachine']  = 'ft'
        a['startmodel']  = ''
        a['algo']  = 'test'
        a['niter']  = 500
        a['cycleniter']  = -1
        a['threshold']  = 0.0
        a['loopgain']  = 0.1
        a['usescratch']  = False
        a['interactive']  = False
        a['clusterdef']  = ''

        a['async']=False
        a['cycleniter'] = {
                    0:odict([{'notvalue':-1}, {'cyclefactor':1.0}, {'minpsffraction':0.05}, {'maxpsffraction':0.8}])}

### This function sets the default values but also will return the list of
### parameters or the default value of a given parameter
        if(param == None):
                myf['__set_default_parameters'](a)
        elif(param == 'paramkeys'):
                return a.keys()
        else:
	        if(a.has_key(param)):
		   #if(type(a[param]) == dict) :
		   #   return a[param][len(a[param])-1]['value']
	   	   #else :
		      return a[param]


#
#
    def check_params(self, param=None, value=None):
      a=inspect.stack() 
      stacklevel=0
      for k in range(len(a)):
        if (string.find(a[k][1], 'ipython console') > 0) or (string.find(a[k][1], '<string>') >= 0):
	    stacklevel=k
	    break
      myf=sys._getframe(stacklevel).f_globals

#      print 'param:', param, 'value:', value
      try :
         if str(type(value)) != "<type 'instance'>" :
            value0 = value
            value = myf['cu'].expandparam(param, value)
            matchtype = False
            if(type(value) == numpy.ndarray):
               if(type(value) == type(value0)):
                  myf[param] = value.tolist()
               else:
                  #print 'value:', value, 'value0:', value0
                  #print 'type(value):', type(value), 'type(value0):', type(value0)
                  myf[param] = value0
                  if type(value0) != list :
                     matchtype = True
            else :
               myf[param] = value
            value = myf['cu'].verifyparam({param:value})
            if matchtype:
               value = False
      except Exception, instance:
         #ignore the exception and just return it unchecked
         myf[param] = value
      return value

#
#
    def description(self, key='tclean', subkey=None):
        desc={'tclean': 'Construct and deconvolve images',
               'vis': 'Name of input visibility file(s)',
               'field': 'field(s) to select',
               'spw': 'spw(s) to select',
               'outlierfile': 'Name of outlier-field image definitions',
               'imagename': 'Pre-name of output images',
               'nchan': 'Number of channels in the output image',
               'imsize': 'Number of pixels',
               'ftmachine': 'Name of FT machine during gridding',
               'startmodel': 'Name of starting model image',
               'algo': 'Name of minor cycle algorithm',
               'niter': 'Maximum number of iterations',
               'cycleniter': 'Maximum number of minor-cycle iterations before triggering a major cycle',
               'cyclefactor': 'Scaling on PSF sidelobe level to compute the minor-cycle stopping threshold.',
               'minpsffraction': 'PSF fraction that marks the max depth of cleaning in the minor cycle ',
               'maxpsffraction': 'PSF fraction that marks the minimum depth of cleaning in the minor cycle ',
               'threshold': 'Stopping threshold (number, in units of Jy)',
               'loopgain': 'Loop gain',
               'usescratch': 'True if to save model visibilities in MODEL_DATA column',
               'interactive': 'True to be able to modify masks and parameters at runtime',
               'clusterdef': 'Name of a file that contains the cluster definition',

               'async': 'If true the taskname must be started using tclean(...)'
              }

#
# Set subfields defaults if needed
#

        if(desc.has_key(key)) :
           return desc[key]

    def itsdefault(self, paramname) :
        a = {}
        a['vis']  = ''
        a['field']  = ''
        a['spw']  = ''
        a['outlierfile']  = ''
        a['imagename']  = ''
        a['nchan']  = 1
        a['imsize']  = [1,1]
        a['ftmachine']  = 'ft'
        a['startmodel']  = ''
        a['algo']  = 'test'
        a['niter']  = 500
        a['cycleniter']  = -1
        a['cyclefactor']  = 1.0
        a['minpsffraction']  = 0.05
        a['maxpsffraction']  = 0.8
        a['threshold']  = 0.0
        a['loopgain']  = 0.1
        a['usescratch']  = False
        a['interactive']  = False
        a['clusterdef']  = ''

        if a.has_key(paramname) :
	      return a[paramname]
tclean_pg = tclean_pg_()
